Summary: Libsafe: Protecting Critical Elements of Stacks
Name: libsafe
Version: 2.0
Release: 16.fdr.1.rh80
# Override upstream 2.0-16 rather than 0.fdr.1 because that is the tarball name
Epoch: 0
License: LGPL
Group: System Environment/Libraries
Source: http://www.research.avayalabs.com/project/libsafe/libsafe-2.0-16.tgz
URL: http://www.research.avayalabs.com/project/libsafe/index.html
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The libsafe library protects a process against the exploitation of buffer
overflow vulnerabilities in process stacks. Libsafe works with any
existing pre-compiled executable and can be used transparently, even on a
system-wide basis. The method intercepts all calls to library functions
that are known to be vulnerable. A substitute version of the corresponding
function implements the original functionality, but in a manner that
ensures that any buffer overflows are contained within the current stack
frame. Libsafe has been shown to detect several known attacks and can
potentially prevent yet unknown attacks. Experiments indicate that the
performance overhead of libsafe is negligible.

If libsafe is compiled on a system with libprelude installed, libsafe will
additionally emit a stack overflow alert to the Prelude Manager.  For more
information about the Prelude Hybrid IDS, please see http://www.prelude-ids.org
(Fedora libsafe is not compiled with libprelude.  Talk to fedora-devel if you
really want this to become default.)

Be aware that any RPMS built while libsafe is installed will require libsafe 
in order to install because of RPM's autodeps. You are encouraged to use a 
chroot for RPM builds rather than a libsafe protected system.


%prep
%setup -q -n libsafe-2.0-16

%build
make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/lib
install -m 0755 src/libsafe.so.2.0.16 $RPM_BUILD_ROOT/lib/libsafe.so.2.0.16

%files
%defattr(-,root,root,-)
%doc README EMAIL_NOTIFICATION LIBPRELUDE COPYING ChangeLog doc tools
/lib/libsafe.so.2.0.16

%clean 
rm -rf $RPM_BUILD_ROOT

%pre
if [ -f /etc/ld.so.preload ] ; then
  echo "Removing libsafe from /etc/ld.so.preload (if exists)"
  cp -fp /etc/ld.so.preload /etc/ld.so.preload.save
  grep -v libsafe /etc/ld.so.preload > /etc/ld.so.preload.tmp
  rm -f /etc/ld.so.preload
fi

%preun
if [ -f /etc/ld.so.preload ] ; then
  echo "Removing libsafe from /etc/ld.so.preload (if exists)"
  cp -fp /etc/ld.so.preload /etc/ld.so.preload.save
  grep -v libsafe /etc/ld.so.preload > /etc/ld.so.preload.tmp
  rm -f /etc/ld.so.preload
fi


%post
/sbin/ldconfig
if [ -s /etc/ld.so.preload.tmp ] ; then
  cp -fp /etc/ld.so.preload.tmp /etc/ld.so.preload
fi
rm -f /etc/ld.so.preload.tmp

if [ -f /lib/libsafe.so.2 ] ; then
  echo "Adding libsafe to ld.so.preload for system wide protection"
  echo "/lib/libsafe.so.2" >> /etc/ld.so.preload
fi

%postun
/sbin/ldconfig
if [ -s /etc/ld.so.preload.tmp ] ; then
  cp -fp /etc/ld.so.preload.tmp /etc/ld.so.preload
fi
rm -f /etc/ld.so.preload.tmp

%changelog
* Mon Apr 14 2003 Warren Togami <warren@togami.com> 2.0-16.fdr.1
- Initial Fedora release, converted from 2.0-16 upstream
